type t = Elt of string * t list | Txt of string | Repeat of int * t list

let rec push l q = match l with
  | [] -> q ()
  | Txt s :: rest -> print_string s; flush stdout;push rest q
  | Repeat (0, e) :: rest -> push rest q
  | Repeat (-1, e) :: rest -> push e (fun () -> push l q)
  | Repeat (n, e) :: rest -> 
      push e (fun () -> push (Repeat(pred n,e)::rest) q)
  | Elt (tag,sub) :: rest -> 
      Printf.printf "<%s>" tag; flush stdout;
      push sub (fun () -> Printf.printf "</%s>" tag; flush stdout; 
		  push rest q)

let int = int_of_string

let rec parse = function
  | Xml.Element ("repeat", [ "arg", n ], sub) ->
      Repeat (int (Sys.argv.(int n)), List.map parse sub)
  | Xml.Element ("repeat", [], sub) ->
      Repeat (-1, List.map parse sub)
  | Xml.Element ("repeat", [ "n",n ], sub) ->
      Repeat (int n, List.map parse sub)
  | Xml.Element (tag, _, sub) ->
      Elt (tag, List.map parse sub)
  | Xml.PCData s ->
      Txt s

let () =
  let p = parse (Xml.parse_in stdin) in
  push [p] (fun () -> ())
  
